CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
                                                     
VAR
  long cap_cog,status
  long bin,bout
  long bstack[8]
   
PUB frames(buffer_in,buffer_out)  

  stop
  bin :=  buffer_in
  bout :=  buffer_out
  return cap_cog := cognew(@entry, @bin) + 1
  

   
PUB stop

'' Stop the capture cog.

  if cap_cog
    cogstop(cap_cog - 1)
    cap_cog~
  
DAT           org 
entry        mov        asm_temp,par
             rdlong     bufin_base,asm_temp

             add        asm_temp,#4              
             rdlong     buf_base,asm_temp
            

:adcpage     
              mov       bufin_ptr,bufin_base
              mov       buf_ptr,buf_base
              mov       asm_temp2,#96 '180       ' number of lines
               
:adcline      mov       asm_temp,#72         ' pixels per line

:adcloop  '   waitcnt   asm_c,asm_cycles     '(timing is determinant after WAITCNT)                                                   
               rdbyte    asm_old,bufin_ptr
               shl      asm_old,#1
              cmp       asm_old,#89 wz,wc ' make sure not over maximum white level
        if_a  mov       asm_old,#89  
'               mov      asm_sample,cnt
'             mov       asm_sample,bufin_ptr 'phsb 
'              sub       asm_sample,asm_old
'              add       asm_old,asm_sample

'              and       asm_sample,#%1111111

'              shr       asm_old,#1       ' dump some noisy bits
'              and       asm_old,table_mask   ' mask off higher bits
'              add       asm_sample,#$2      ' add lowest valid grey
'              cmp       asm_sample,#7 wz,wc ' make sure not over maximum white level
'        if_a  mov       asm_sample,#7
'              shl       asm_sample,#1
'              mov       asm_temp,asm_old
'              add       asm_temp,asm_old
'              shl       asm_old,#16
              add       asm_old,table_log       
              rdword    asm_sample,asm_old
              shr       asm_sample,#7      'nth root 
              
'              and       asm_sample,#%0111
'              add       asm_sample,#1      ' add lowest valid grey
              and       asm_sample,#%0111
              cmp       asm_sample,#6 wz,wc ' make sure not over maximum white level
        if_a  mov       asm_sample,#6  
              add       asm_sample,#1      ' add lowest valid grey
              
              wrbyte    asm_sample,buf_ptr  ' write sample back to Spin variable "sample" 

              add       bufin_ptr,#1          ' (WRXXXX introduces timing indeterminancy here..)
              add       buf_ptr,#1
              djnz      asm_temp,#:adcloop
              
              add       buf_ptr,#8
              add       bufin_ptr,#80'76 '#4
              djnz      asm_temp2,#:adcline
              
              JMP       #:adcpage

   
_Status       LONG      0
table_mask    long      $0FFe
table_log     long      $c000


asm_new       res       1
asm_old       res       1
asm_temp      res       1
asm_temp2     res       1
asm_sample    res       1
  
_frame_cnt    res       1
_lineCnt      res       1
_timeCnt      RES       1             ' Used with WAITCNT to make delays
mycog         res       1
buf_base      res       1
buf_ptr       res       1
buf_end       res       1
bufin_base    res       1
bufin_ptr     res       1
switch        res       1